diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/lte/helper/radio-environment-map-helper.cc ns-3.34/src/lte/helper/radio-environment-map-helper.cc
--- ns-3.33/src/lte/helper/radio-environment-map-helper.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/lte/helper/radio-environment-map-helper.cc	2021-07-14 10:31:06.000000000 -0700
@@ -28,6 +28,7 @@
 #include <ns3/uinteger.h>
 #include <ns3/string.h>
 #include <ns3/boolean.h>
+#include <ns3/pointer.h>
 #include <ns3/spectrum-channel.h>
 #include <ns3/config.h>
 #include <ns3/rem-spectrum-phy.h>
@@ -72,7 +73,16 @@
     .SetParent<Object> ()
     .SetGroupName("Lte")
     .AddConstructor<RadioEnvironmentMapHelper> ()
-    .AddAttribute ("ChannelPath", "The path to the channel for which the Radio Environment Map is to be generated",
+    .AddAttribute ("Channel",
+                   "The DL spectrum channel for which the RadioEnvironment Map is to be generated. "
+                   "Alternatively ChannelPath attribute can be used."
+                   "Only one of the two (Channel or ChannelPath) should be set.",
+                   PointerValue (nullptr),
+                   MakePointerAccessor (&RadioEnvironmentMapHelper::m_channel),
+                   MakePointerChecker<SpectrumChannel> ())
+    .AddAttribute ("ChannelPath", "The path to the channel for which the Radio Environment Map is to be generated."
+                   "This attribute is an alternative to Channel attribute and is only used if Channel is not set (equal to nullptr). "
+                   "Only one of the two (Channel or ChannelPath) should be set.",
                    StringValue ("/ChannelList/0"),
                    MakeStringAccessor (&RadioEnvironmentMapHelper::m_channelPath),
                    MakeStringChecker ())
@@ -185,13 +195,17 @@
     {
       NS_FATAL_ERROR ("only one REM supported per instance of RadioEnvironmentMapHelper");
     }
-  Config::MatchContainer match = Config::LookupMatches (m_channelPath);
-  if (match.GetN () != 1)
+
+  if (m_channel == nullptr) // if Channel attribute is not set, then use the ChannelPath attribute
     {
-      NS_FATAL_ERROR ("Lookup " << m_channelPath << " should have exactly one match");
+      Config::MatchContainer match = Config::LookupMatches (m_channelPath);
+      if (match.GetN () != 1)
+        {
+          NS_FATAL_ERROR ("Lookup " << m_channelPath << " should have exactly one match");
+        }
+      m_channel = match.Get (0)->GetObject<SpectrumChannel> ();
+      NS_ABORT_MSG_IF (m_channel == 0, "object at " << m_channelPath << " is not of type SpectrumChannel");
     }
-  m_channel = match.Get (0)->GetObject<SpectrumChannel> ();
-  NS_ABORT_MSG_IF (m_channel == 0, "object at " << m_channelPath << "is not of type SpectrumChannel");
 
   m_outFile.open (m_outputFile.c_str ());
   if (!m_outFile.is_open ())
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/lte/helper/radio-environment-map-helper.h ns-3.34/src/lte/helper/radio-environment-map-helper.h
--- ns-3.33/src/lte/helper/radio-environment-map-helper.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/lte/helper/radio-environment-map-helper.h	2021-07-14 10:31:06.000000000 -0700
@@ -137,12 +137,23 @@
  
   double m_z;  ///< The `Z` attribute.
 
-  std::string m_channelPath;  ///< The `ChannelPath` attribute.
+  /**
+   * The `ChannelPath` attribute. If `Channel` attribute is not set, then
+   * `ChannelPath` will be used to determine the DL channel object for which
+   * the REM will be created.
+   */
+  std::string m_channelPath;
+
   std::string m_outputFile;   ///< The `OutputFile` attribute.
 
   bool m_stopWhenDone;   ///< The `StopWhenDone` attribute.
   
-  /// The channel object taken from the `ChannelPath` attribute.
+  /**
+   * The `Channel` attribute, which is a direct pointer to the DL channel
+   * object for which will be created the REM. Alternatively, `ChannelPath`
+   * attribute can be used. If `ChannelPath` attribute is being used then the
+   * m_channel object is configured by using the `ChannelPath` attribute value.
+   */
   Ptr<SpectrumChannel> m_channel;
 
   double m_noisePower;  ///< The `NoisePower` attribute.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/lte/model/epc-x2-sap.h ns-3.34/src/lte/model/epc-x2-sap.h
--- ns-3.33/src/lte/model/epc-x2-sap.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/lte/model/epc-x2-sap.h	2021-07-14 10:31:06.000000000 -0700
@@ -142,10 +142,10 @@
   struct RelativeNarrowbandTxBand
   {
     std::vector <bool> rntpPerPrbList; ///< RNTP per prb list
-    int16_t     rntpThreshold; ///< RNTP threshold
-    uint16_t    antennaPorts; ///< antenna ports
-    uint16_t    pB; ///< PB
-    uint16_t    pdcchInterferenceImpact; ///< PDC channel interference list
+    int16_t     rntpThreshold {INT16_MIN}; ///< RNTP threshold
+    uint16_t    antennaPorts {UINT16_MAX}; ///< antenna ports
+    uint16_t    pB {UINT16_MAX}; ///< PB
+    uint16_t    pdcchInterferenceImpact {UINT16_MAX}; ///< PDC channel interference list
   };
 
   /**
@@ -302,7 +302,7 @@
    */
   struct LoadInformationParams
   {
-    uint16_t            targetCellId; ///< target cell ID
+    uint16_t            targetCellId {UINT16_MAX}; ///< target cell ID
     std::vector <CellInformationItem> cellInformationList; ///< cell information list
   };
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/lte/model/fading-traces/fading_trace_generator.m ns-3.34/src/lte/model/fading-traces/fading_trace_generator.m
--- ns-3.33/src/lte/model/fading-traces/fading_trace_generator.m	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/lte/model/fading-traces/fading_trace_generator.m	2021-07-14 10:31:07.000000000 -0700
@@ -42,12 +42,9 @@
 
 
 % create the channel object
-c = rayleighchan(ts, fd, delays_pedestrianEPA, power_pedestrianEPA);
-%c = rayleighchan(ts, fd, delays_vehicularEVA, power_vehicularEVA);
-%c = rayleighchan(ts, fd, delays_urbanETU, power_urbanETU);
-%c.StorePathGains = 1;
-c.ResetBeforeFiltering = 0;
-c.NormalizePathGains = 1;
+c = comm.RayleighChannel('SampleRate', 1/ts, 'MaximumDopplerShift', fd, 'PathDelays', delays_pedestrianEPA, 'AveragePathGains', power_pedestrianEPA);
+%c = comm.RayleighChannel('SampleRate', 1/ts, 'MaximumDopplerShift', fd, 'PathDelays', delays_vehicularEVA, 'AveragePathGains', power_vehicularEVA);
+%c = comm.RayleighChannel('SampleRate', 1/ts, 'MaximumDopplerShift', fd, 'PathDelays', delays_urbanETU, 'AveragePathGains', power_urbanETU);
 
 TTI = 0.001;
 
@@ -67,7 +64,7 @@
 for ii=1:round((traceDuration/TTI))
         
     % y is the frequency response of the channel
-    y = filter(c,sig);   
+    y = c(sig);   
     
 %     [Pxx,F] = PWELCH(X,WINDOW,NOVERLAP,NFFT,Fs) returns a PSD computed as
 %     a function of physical frequency (Hz).  Fs is the sampling frequency
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/lte/model/ff-mac-common.h ns-3.34/src/lte/model/ff-mac-common.h
--- ns-3.33/src/lte/model/ff-mac-common.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/lte/model/ff-mac-common.h	2021-07-14 10:31:07.000000000 -0700
@@ -92,44 +92,45 @@
  */
 struct DlDciListElement_s
 {
-  uint16_t  m_rnti; ///< RNTI
-  uint32_t  m_rbBitmap; ///< RB bitmap
-  uint8_t   m_rbShift; ///< RB shift
-  uint8_t   m_resAlloc; ///< The type of resource allocation
+  uint16_t  m_rnti {UINT16_MAX}; ///< RNTI
+  uint32_t  m_rbBitmap {UINT8_MAX}; ///< RB bitmap
+  uint8_t   m_rbShift {UINT8_MAX}; ///< RB shift
+  uint8_t   m_resAlloc {UINT8_MAX}; ///< The type of resource allocation
   std::vector <uint16_t>  m_tbsSize; ///< The TBs size
   std::vector <uint8_t>   m_mcs; ///< MCS
   std::vector <uint8_t>   m_ndi; ///< New data indicator
   std::vector <uint8_t>   m_rv; ///< Redundancy version
-  uint8_t   m_cceIndex; ///< Control Channel Element index
-  uint8_t   m_aggrLevel; ///< The aggregation level
-  uint8_t   m_precodingInfo; ///< precoding info
+  uint8_t   m_cceIndex {UINT8_MAX}; ///< Control Channel Element index
+  uint8_t   m_aggrLevel {UINT8_MAX}; ///< The aggregation level
+  uint8_t   m_precodingInfo {UINT8_MAX}; ///< precoding info
   /// Format enumeration
   enum Format_e
   {
-    ONE, ONE_A, ONE_B, ONE_C, ONE_D, TWO, TWO_A, TWO_B
-  } m_format; ///< the format
-  uint8_t   m_tpc; ///< Tx power control command
-  uint8_t   m_harqProcess; ///< HARQ process
-  uint8_t   m_dai; ///< DL assignment index
+    ONE, ONE_A, ONE_B, ONE_C, ONE_D, TWO, TWO_A, TWO_B, NotValid_Dci_Format
+  } m_format {NotValid_Dci_Format}; ///< the format
+  uint8_t   m_tpc {UINT8_MAX}; ///< Tx power control command
+  uint8_t   m_harqProcess {UINT8_MAX}; ///< HARQ process
+  uint8_t   m_dai {UINT8_MAX}; ///< DL assignment index
   /// Vrb Format enum
   enum VrbFormat_e
   {
     VRB_DISTRIBUTED,
-    VRB_LOCALIZED
-  } m_vrbFormat; ///< the format
-  bool      m_tbSwap; ///< swap?
-  bool      m_spsRelease; ///< release?
-  bool      m_pdcchOrder; ///< cch order?
-  uint8_t   m_preambleIndex; ///< preamble index
-  uint8_t   m_prachMaskIndex; ///< RACH mask index
+    VRB_LOCALIZED,
+    NotValid_VRB_Format
+  } m_vrbFormat {NotValid_VRB_Format}; ///< the format
+  bool      m_tbSwap {false}; ///< swap?
+  bool      m_spsRelease {false}; ///< release?
+  bool      m_pdcchOrder {false}; ///< cch order?
+  uint8_t   m_preambleIndex {UINT8_MAX}; ///< preamble index
+  uint8_t   m_prachMaskIndex {UINT8_MAX}; ///< RACH mask index
   /// Ngap enum
   enum Ngap_e
   {
-    GAP1, GAP2
-  } m_nGap; ///< the gap
-  uint8_t   m_tbsIdx; ///< tbs index
-  uint8_t   m_dlPowerOffset; ///< DL power offset
-  uint8_t   m_pdcchPowerOffset; ///<  CCH power offset
+    GAP1, GAP2, NotValid_Ngap
+  } m_nGap {NotValid_Ngap}; ///< the gap
+  uint8_t   m_tbsIdx {UINT8_MAX}; ///< tbs index
+  uint8_t   m_dlPowerOffset {UINT8_MAX}; ///< DL power offset
+  uint8_t   m_pdcchPowerOffset {UINT8_MAX}; ///<  CCH power offset
 };
 
 /**
@@ -138,23 +139,23 @@
  */
 struct UlDciListElement_s
 {
-  uint16_t  m_rnti; ///< RNTI
-  uint8_t   m_rbStart; ///< start
-  uint8_t   m_rbLen; ///< length
-  uint16_t  m_tbSize; ///< size
-  uint8_t   m_mcs; ///< MCS
-  uint8_t   m_ndi; ///< NDI
-  uint8_t   m_cceIndex; ///< Control Channel Element index
-  uint8_t   m_aggrLevel; ///< The aggregation level
-  uint8_t   m_ueTxAntennaSelection; ///< UE antenna selection
-  bool      m_hopping; ///< hopping?
-  uint8_t   m_n2Dmrs; ///< n2 DMRS
-  int8_t    m_tpc; ///< Tx power control command
-  bool      m_cqiRequest; ///< CQI request
-  uint8_t   m_ulIndex; ///< UL index
-  uint8_t   m_dai; ///< DL assignment index
-  uint8_t   m_freqHopping; ///< freq hopping
-  int8_t    m_pdcchPowerOffset; ///< CCH power offset
+  uint16_t  m_rnti {UINT16_MAX}; ///< RNTI
+  uint8_t   m_rbStart {UINT8_MAX}; ///< start
+  uint8_t   m_rbLen {UINT8_MAX}; ///< length
+  uint16_t  m_tbSize {UINT16_MAX}; ///< size
+  uint8_t   m_mcs {UINT8_MAX}; ///< MCS
+  uint8_t   m_ndi {UINT8_MAX}; ///< NDI
+  uint8_t   m_cceIndex {UINT8_MAX}; ///< Control Channel Element index
+  uint8_t   m_aggrLevel {UINT8_MAX}; ///< The aggregation level
+  uint8_t   m_ueTxAntennaSelection {UINT8_MAX}; ///< UE antenna selection
+  bool      m_hopping {false}; ///< hopping?
+  uint8_t   m_n2Dmrs {UINT8_MAX}; ///< n2 DMRS
+  int8_t    m_tpc {INT8_MIN}; ///< Tx power control command
+  bool      m_cqiRequest {false}; ///< CQI request
+  uint8_t   m_ulIndex {UINT8_MAX}; ///< UL index
+  uint8_t   m_dai {UINT8_MAX}; ///< DL assignment index
+  uint8_t   m_freqHopping {UINT8_MAX}; ///< freq hopping
+  int8_t    m_pdcchPowerOffset {INT8_MIN}; ///< CCH power offset
 };
 
 /**
@@ -172,8 +173,8 @@
  */
 struct VendorSpecificListElement_s
 {
-  uint32_t m_type; ///< type
-  uint32_t m_length; ///< length
+  uint32_t m_type {UINT32_MAX}; ///< type
+  uint32_t m_length {UINT32_MAX}; ///< length
   Ptr<VendorSpecificValue> m_value; ///< value
 };
 
@@ -183,29 +184,31 @@
  */
 struct LogicalChannelConfigListElement_s
 {
-  uint8_t   m_logicalChannelIdentity; ///< logical channel identity
-  uint8_t   m_logicalChannelGroup; ///< logical channel group
+  uint8_t   m_logicalChannelIdentity {UINT8_MAX}; ///< logical channel identity
+  uint8_t   m_logicalChannelGroup {UINT8_MAX}; ///< logical channel group
 
   /// Direction enum
   enum Direction_e
   {
     DIR_UL,
     DIR_DL,
-    DIR_BOTH
-  } m_direction; ///< the direction
+    DIR_BOTH,
+    NotValid
+  } m_direction {NotValid}; ///< the direction
 
   /// QosBearerType enum
   enum QosBearerType_e
   {
     QBT_NON_GBR,
-    QBT_GBR
-  } m_qosBearerType; ///< the QOS bearer type
-
-  uint8_t   m_qci; ///< QCI
-  uint64_t  m_eRabMaximulBitrateUl; ///< ERAB maximum bit rate UL
-  uint64_t  m_eRabMaximulBitrateDl; ///< ERAB maximum bit rate DL
-  uint64_t  m_eRabGuaranteedBitrateUl; ///< ERAB guaranteed bit rate UL
-  uint64_t  m_eRabGuaranteedBitrateDl; ///< ERAB guaranteed bit rate DL
+    QBT_GBR,
+    NotValid_QosBearerType
+  } m_qosBearerType {NotValid_QosBearerType}; ///< the QOS bearer type
+
+  uint8_t   m_qci {UINT8_MAX}; ///< QCI
+  uint64_t  m_eRabMaximulBitrateUl {UINT64_MAX}; ///< ERAB maximum bit rate UL
+  uint64_t  m_eRabMaximulBitrateDl {UINT64_MAX}; ///< ERAB maximum bit rate DL
+  uint64_t  m_eRabGuaranteedBitrateUl {UINT64_MAX}; ///< ERAB guaranteed bit rate UL
+  uint64_t  m_eRabGuaranteedBitrateDl {UINT64_MAX}; ///< ERAB guaranteed bit rate DL
 };
 
 /**
@@ -214,8 +217,8 @@
  */
 struct RachListElement_s
 {
-  uint16_t  m_rnti; ///< RNTI
-  uint16_t  m_estimatedSize; ///< estimated size
+  uint16_t  m_rnti {UINT16_MAX}; ///< RNTI
+  uint16_t  m_estimatedSize {UINT16_MAX}; ///< estimated size
 };
 
 /**
@@ -224,12 +227,12 @@
  */
 struct PhichListElement_s
 {
-  uint16_t  m_rnti; ///< RNTI
+  uint16_t  m_rnti {UINT16_MAX}; ///< RNTI
   /// Phich enum
   enum Phich_e
   {
-    ACK, NACK
-  } m_phich; ///< the phich
+    ACK, NACK, NotValid
+  } m_phich {NotValid}; ///< the phich
 };
 
 /**
@@ -237,8 +240,8 @@
  */
 struct RlcPduListElement_s
 {
-  uint8_t   m_logicalChannelIdentity; ///< logical channel identity
-  uint16_t  m_size; ///< size
+  uint8_t   m_logicalChannelIdentity {UINT8_MAX}; ///< logical channel identity
+  uint16_t  m_size {UINT16_MAX}; ///< size
 };
 
 /**
@@ -247,7 +250,7 @@
  */
 struct BuildDataListElement_s
 {
-  uint16_t  m_rnti; ///< RNTI
+  uint16_t  m_rnti {UINT16_MAX}; ///< RNTI
   struct DlDciListElement_s m_dci; ///< DCI
   std::vector <enum CeBitmap_e> m_ceBitmap; ///< CE bitmap
   std::vector < std::vector <struct RlcPduListElement_s> > m_rlcPduList; ///< RLC PDU list
@@ -258,15 +261,15 @@
  */
 struct UlGrant_s
 {
-  uint16_t m_rnti; ///< RNTI
-  uint8_t m_rbStart; ///< start
-  uint8_t m_rbLen; ///< length
-  uint16_t m_tbSize; ///< size
-  uint8_t m_mcs; ///< MCS
-  bool m_hopping; ///< hopping?
-  int8_t m_tpc; ///< Tx power control command
-  bool m_cqiRequest; ///< CQI request?
-  bool m_ulDelay; ///< UL delay?
+  uint16_t m_rnti {UINT16_MAX}; ///< RNTI
+  uint8_t m_rbStart {UINT8_MAX}; ///< start
+  uint8_t m_rbLen {UINT8_MAX}; ///< length
+  uint16_t m_tbSize {UINT16_MAX}; ///< size
+  uint8_t m_mcs {UINT8_MAX}; ///< MCS
+  bool m_hopping {false}; ///< hopping?
+  int8_t m_tpc {INT8_MIN}; ///< Tx power control command
+  bool m_cqiRequest {false}; ///< CQI request?
+  bool m_ulDelay {false}; ///< UL delay?
 }; 
 
 /**
@@ -274,7 +277,7 @@
  */
 struct BuildRarListElement_s
 {
-  uint16_t  m_rnti; ///< RNTI
+  uint16_t  m_rnti {UINT16_MAX}; ///< RNTI
   //uint32_t  m_grant; // Substituted with type UlGrant_s
   UlGrant_s m_grant; ///< grant
   struct DlDciListElement_s m_dci; ///< DCI
@@ -288,9 +291,9 @@
   /// Type enum
   enum Type_e
   {
-    BCCH, PCCH
-  } m_type; ///< the type
-  uint8_t m_index; ///< index
+    BCCH, PCCH, NotValid
+  } m_type {NotValid}; ///< the type
+  uint8_t m_index {UINT8_MAX}; ///< index
   struct DlDciListElement_s m_dci; ///< DCI
 };
 
@@ -299,14 +302,14 @@
  */
 struct UlInfoListElement_s
 {
-  uint16_t  m_rnti; ///< RNTI
+  uint16_t  m_rnti {UINT16_MAX}; ///< RNTI
   std::vector <uint16_t> m_ulReception; ///< UL reception
   /// Reception status enum
   enum ReceptionStatus_e 
   {
     Ok, NotOk, NotValid
-  } m_receptionStatus; ///< the status
-  uint8_t   m_tpc; ///< Tx power control command
+  } m_receptionStatus {NotValid}; ///< the status
+  uint8_t   m_tpc {UINT8_MAX}; ///< Tx power control command
 };
 
 /**
@@ -314,7 +317,7 @@
  */
 struct SrListElement_s
 {
-  uint16_t  m_rnti; ///< RNTI
+  uint16_t  m_rnti {UINT16_MAX}; ///< RNTI
 };
 
 /**
@@ -322,8 +325,8 @@
  */
 struct MacCeValue_u
 {
-  uint8_t   m_phr; ///< phr
-  uint8_t   m_crnti; ///< NRTI
+  uint8_t   m_phr {UINT8_MAX}; ///< phr
+  uint8_t   m_crnti {UINT8_MAX}; ///< NRTI
   std::vector <uint8_t> m_bufferStatus; ///< buffer status
 };
 
@@ -332,12 +335,12 @@
  */
 struct MacCeListElement_s
 {
-  uint16_t  m_rnti; ///< RNTI
+  uint16_t  m_rnti {UINT16_MAX}; ///< RNTI
   /// MAC CE type enum
   enum MacCeType_e
   {
-    BSR, PHR, CRNTI
-  } m_macCeType; ///< MAC CE type
+    BSR, PHR, CRNTI, NotValid
+  } m_macCeType {NotValid}; ///< MAC CE type
   struct MacCeValue_u m_macCeValue; ///< MAC CE value
 };
 
@@ -346,13 +349,13 @@
  */
 struct DrxConfig_s
 {
-  uint8_t   m_onDurationTimer; ///< on duration timer
-  uint16_t  m_drxInactivityTimer; ///< inactivity timer
-  uint16_t  m_drxRetransmissionTimer; ///< retransmission timer
-  uint16_t  m_longDrxCycle; ///< long DRX cycle 
-  uint16_t  m_longDrxCycleStartOffset; ///< long DRX cycle start offset
-  uint16_t  m_shortDrxCycle; ///< short DRX cycle
-  uint8_t   m_drxShortCycleTimer; ///< short DRX cycle timer
+  uint8_t   m_onDurationTimer {UINT8_MAX}; ///< on duration timer
+  uint16_t  m_drxInactivityTimer {UINT16_MAX}; ///< inactivity timer
+  uint16_t  m_drxRetransmissionTimer {UINT16_MAX}; ///< retransmission timer
+  uint16_t  m_longDrxCycle {UINT16_MAX}; ///< long DRX cycle
+  uint16_t  m_longDrxCycleStartOffset {UINT16_MAX}; ///< long DRX cycle start offset
+  uint16_t  m_shortDrxCycle {UINT16_MAX}; ///< short DRX cycle
+  uint8_t   m_drxShortCycleTimer {UINT8_MAX}; ///< short DRX cycle timer
 };
 
 /**
@@ -360,12 +363,12 @@
  */
 struct SpsConfig_s
 {
-  uint16_t  m_semiPersistSchedIntervalUl; ///< UL semi persist schedule interval
-  uint16_t  m_semiPersistSchedIntervalDl; ///< DL semi persist schedule interval
-  uint8_t   m_numberOfConfSpsProcesses; ///< number of conf SPS process
-  uint8_t   m_n1PucchAnPersistentListSize; ///< N1pu CCH  persistent list size
+  uint16_t  m_semiPersistSchedIntervalUl {UINT16_MAX}; ///< UL semi persist schedule interval
+  uint16_t  m_semiPersistSchedIntervalDl {UINT16_MAX}; ///< DL semi persist schedule interval
+  uint8_t   m_numberOfConfSpsProcesses {UINT8_MAX}; ///< number of conf SPS process
+  uint8_t   m_n1PucchAnPersistentListSize {UINT8_MAX}; ///< N1pu CCH  persistent list size
   std::vector <uint16_t> m_n1PucchAnPersistentList; ///< N1pu CCH persistent list
-  uint8_t   m_implicitReleaseAfter; ///< implicit release after
+  uint8_t   m_implicitReleaseAfter {UINT8_MAX}; ///< implicit release after
 };
 
 /**
@@ -373,9 +376,9 @@
  */
 struct SrConfig_s
 {
-  enum SetupRelease_e m_action; ///< action
-  uint8_t   m_schedInterval; ///< sched interval
-  uint8_t   m_dsrTransMax; ///< trans max
+  enum SetupRelease_e m_action {setup}; ///< action
+  uint8_t   m_schedInterval {UINT8_MAX}; ///< sched interval
+  uint8_t   m_dsrTransMax {UINT8_MAX}; ///< trans max
 };
 
 /**
@@ -383,9 +386,9 @@
  */
 struct CqiConfig_s
 {
-  enum SetupRelease_e m_action; ///< action
-  uint16_t  m_cqiSchedInterval; ///< CQI schedule interval
-  uint8_t   m_riSchedInterval; ///< RI schedule interval
+  enum SetupRelease_e m_action {setup}; ///< action
+  uint16_t  m_cqiSchedInterval {UINT16_MAX}; ///< CQI schedule interval
+  uint8_t   m_riSchedInterval {UINT8_MAX}; ///< RI schedule interval
 };
 
 /**
@@ -393,11 +396,11 @@
  */
 struct UeCapabilities_s
 {
-  bool      m_halfDuplex; ///< half duplex
-  bool      m_intraSfHopping; ///< intra SF hopping
-  bool      m_type2Sb1; ///< type 2Sb1
-  uint8_t   m_ueCategory; ///< UE category
-  bool      m_resAllocType1; ///< alloc type 1
+  bool      m_halfDuplex {false}; ///< half duplex
+  bool      m_intraSfHopping {false}; ///< intra SF hopping
+  bool      m_type2Sb1 {false}; ///< type 2Sb1
+  uint8_t   m_ueCategory {UINT8_MAX}; ///< UE category
+  bool      m_resAllocType1 {false}; ///< alloc type 1
 };
 
 /**
@@ -405,8 +408,8 @@
  */
 struct SiMessageListElement_s
 {
-  uint16_t  m_periodicity; ///< periodicity
-  uint16_t  m_length; ///< length
+  uint16_t  m_periodicity {UINT16_MAX}; ///< periodicity
+  uint16_t  m_length {UINT16_MAX}; ///< length
 };
 
 /**
@@ -414,9 +417,9 @@
  */
 struct SiConfiguration_s
 {
-  uint16_t  m_sfn; ///< sfn
-  uint16_t  m_sib1Length; ///< sib1 length
-  uint8_t   m_siWindowLength; ///< window length
+  uint16_t  m_sfn {UINT16_MAX}; ///< sfn
+  uint16_t  m_sib1Length {UINT16_MAX}; ///< sib1 length
+  uint8_t   m_siWindowLength {UINT8_MAX}; ///< window length
   std::vector <struct SiMessageListElement_s> m_siMessageList; ///< message list
 };
 
@@ -425,8 +428,8 @@
  */
 struct DlInfoListElement_s
 {
-  uint16_t  m_rnti; ///< RNTI
-  uint8_t   m_harqProcessId; ///< HARQ process ID
+  uint16_t  m_rnti {UINT16_MAX}; ///< RNTI
+  uint8_t   m_harqProcessId {UINT8_MAX}; ///< HARQ process ID
   /// HARQ status enum
   enum HarqStatus_e
   {
@@ -440,9 +443,9 @@
  */
 struct BwPart_s
 {
-  uint8_t   m_bwPartIndex; ///< bw part index
-  uint8_t   m_sb; ///< sb
-  uint8_t   m_cqi; ///< CQI
+  uint8_t   m_bwPartIndex {UINT8_MAX}; ///< bw part index
+  uint8_t   m_sb {UINT8_MAX}; ///< sb
+  uint8_t   m_cqi {UINT8_MAX}; ///< CQI
 };
 
 /**
@@ -450,7 +453,7 @@
  */
 struct HigherLayerSelected_s
 {
-  uint8_t   m_sbPmi; ///< sb PMI
+  uint8_t   m_sbPmi {UINT8_MAX}; ///< sb PMI
   std::vector <uint8_t> m_sbCqi; ///< sb CQI
 };
 
@@ -460,7 +463,7 @@
 struct UeSelected_s
 {
   std::vector <uint8_t> m_sbList; ///< sb list
-  uint8_t   m_sbPmi; ///< sb PMI
+  uint8_t   m_sbPmi {UINT8_MAX}; ///< sb PMI
   std::vector <uint8_t> m_sbCqi; ///< sb CQI
 };
 
@@ -479,15 +482,15 @@
  */
 struct CqiListElement_s
 {
-  uint16_t  m_rnti; ///< RNTI
-  uint8_t   m_ri; ///< RI
+  uint16_t  m_rnti {UINT16_MAX}; ///< RNTI
+  uint8_t   m_ri {UINT8_MAX}; ///< RI
   /// CqiType_e enumeration
   enum CqiType_e
   {
-    P10, P11, P20, P21, A12, A22, A20, A30, A31
-  } m_cqiType; ///< CQI type
+    P10, P11, P20, P21, A12, A22, A20, A30, A31, NotValid
+  } m_cqiType {NotValid}; ///< CQI type
   std::vector <uint8_t> m_wbCqi; ///< wb CQI
-  uint8_t   m_wbPmi; ///< wb PMI
+  uint8_t   m_wbPmi {UINT8_MAX}; ///< wb PMI
 
   struct SbMeasResult_s m_sbMeasResult; ///< sb measure result
 };
@@ -505,8 +508,9 @@
     PUSCH,
     PUCCH_1,
     PUCCH_2,
-    PRACH
-  } m_type; ///< type
+    PRACH,
+    NotValid
+  } m_type {NotValid}; ///< type
 };
 
 /**
@@ -514,9 +518,9 @@
  */
 struct PagingInfoListElement_s
 {
-  uint8_t   m_pagingIndex; ///< paging index
-  uint16_t  m_pagingMessageSize; ///< paging message size
-  uint8_t   m_pagingSubframe; ///< paging subframe
+  uint8_t   m_pagingIndex {UINT8_MAX}; ///< paging index
+  uint16_t  m_pagingMessageSize {UINT16_MAX}; ///< paging message size
+  uint8_t   m_pagingSubframe {UINT8_MAX}; ///< paging subframe
 };
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/lte/model/lte-asn1-header.cc ns-3.34/src/lte/model/lte-asn1-header.cc
--- ns-3.33/src/lte/model/lte-asn1-header.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/lte/model/lte-asn1-header.cc	2021-07-14 10:31:07.000000000 -0700
@@ -321,7 +321,14 @@
 
 void Asn1Header::SerializeInteger (int n, int nmin, int nmax) const
 {
-  NS_ASSERT_MSG (nmin <= n && n <= nmax,
+  // The following is equivalent to:
+  //  NS_ASSERT_MSG (nmin <= n && n <= nmax,
+  //               "Integer " << n << " is outside range [" << nmin << ", " << nmax << "]");
+  // This is a workaround to gcc-7 aggressive optimization, see #346, and can be dropped
+  // once gcc-7 will not be anymore supported.
+  long int nComp = nmin;
+  nComp -= n;
+  NS_ASSERT_MSG (nComp <= 0 && n <= nmax,
                  "Integer " << n << " is outside range [" << nmin << ", " << nmax << "]");
 
   // Clause 11.5.3 ITU-T X.691
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/lte/model/lte-enb-mac.cc ns-3.34/src/lte/model/lte-enb-mac.cc
--- ns-3.33/src/lte/model/lte-enb-mac.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/lte/model/lte-enb-mac.cc	2021-07-14 10:31:07.000000000 -0700
@@ -996,7 +996,7 @@
        */
       if ((it != m_allocatedNcRaPreambleMap.end ()) && (it->second.expiryTime < Simulator::Now ()))
         {
-          if (!m_cmacSapUser->IsRandomAccessCompleted (rnti))
+          if (!m_cmacSapUser->IsRandomAccessCompleted (it->second.rnti))
             {
               //random access of the UE is not completed,
               //check other preambles
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/lte/model/lte-enb-rrc.cc ns-3.34/src/lte/model/lte-enb-rrc.cc
--- ns-3.33/src/lte/model/lte-enb-rrc.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/lte/model/lte-enb-rrc.cc	2021-07-14 10:31:07.000000000 -0700
@@ -2443,9 +2443,14 @@
 LteEnbRrc::DoRecvIdealUeContextRemoveRequest (uint16_t rnti)
 {
   NS_LOG_FUNCTION (this << rnti);
-  GetUeManager (rnti)->RecvIdealUeContextRemoveRequest (rnti);
-  //delete the UE context at the eNB
-  RemoveUe (rnti);
+  // TODO: remove after merge of ho_failure branch
+  // check if the RNTI to be removed is not stale
+  if (HasUeManager (rnti))
+    {
+      GetUeManager (rnti)->RecvIdealUeContextRemoveRequest (rnti);
+      // delete the UE context at the eNB
+      RemoveUe (rnti);
+    }
 }
 
 void
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/lte/model/lte-pdcp.cc ns-3.34/src/lte/model/lte-pdcp.cc
--- ns-3.33/src/lte/model/lte-pdcp.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/lte/model/lte-pdcp.cc	2021-07-14 10:31:07.000000000 -0700
@@ -174,9 +174,10 @@
 ////////////////////////////////////////
 
 void
-LtePdcp::DoTransmitPdcpSdu (Ptr<Packet> p)
+LtePdcp::DoTransmitPdcpSdu (LtePdcpSapProvider::TransmitPdcpSduParameters params)
 {
-  NS_LOG_FUNCTION (this << m_rnti << (uint32_t) m_lcid << p->GetSize ());
+  NS_LOG_FUNCTION (this << m_rnti << static_cast <uint16_t> (m_lcid) << params.pdcpSdu->GetSize ());
+  Ptr<Packet> p = params.pdcpSdu;
 
   // Sender timestamp
   PdcpTag pdcpTag (Simulator::Now ());
@@ -198,12 +199,12 @@
 
   m_txPdu (m_rnti, m_lcid, p->GetSize ());
 
-  LteRlcSapProvider::TransmitPdcpPduParameters params;
-  params.rnti = m_rnti;
-  params.lcid = m_lcid;
-  params.pdcpPdu = p;
+  LteRlcSapProvider::TransmitPdcpPduParameters txParams;
+  txParams.rnti = m_rnti;
+  txParams.lcid = m_lcid;
+  txParams.pdcpPdu = p;
 
-  m_rlcSapProvider->TransmitPdcpPdu (params);
+  m_rlcSapProvider->TransmitPdcpPdu (txParams);
 }
 
 void
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/lte/model/lte-pdcp.h ns-3.34/src/lte/model/lte-pdcp.h
--- ns-3.33/src/lte/model/lte-pdcp.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/lte/model/lte-pdcp.h	2021-07-14 10:31:07.000000000 -0700
@@ -145,9 +145,9 @@
   /**
    * Interface provided to upper RRC entity
    *
-   * \param p packet
+   * \param params the TransmitPdcpSduParameters
    */
-  virtual void DoTransmitPdcpSdu (Ptr<Packet> p);
+  virtual void DoTransmitPdcpSdu (LtePdcpSapProvider::TransmitPdcpSduParameters params);
 
   LtePdcpSapUser* m_pdcpSapUser; ///< PDCP SAP user
   LtePdcpSapProvider* m_pdcpSapProvider; ///< PDCP SAP provider
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/lte/model/lte-pdcp-sap.h ns-3.34/src/lte/model/lte-pdcp-sap.h
--- ns-3.33/src/lte/model/lte-pdcp-sap.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/lte/model/lte-pdcp-sap.h	2021-07-14 10:31:07.000000000 -0700
@@ -48,9 +48,10 @@
   };
 
   /**
-   * Send a RRC PDU to the RDCP for transmission
-   * This method is to be called
-   * when upper RRC entity has a RRC PDU ready to send   
+   * Send RRC PDU parameters to the PDCP for transmission
+   *
+   * This method is to be called when upper RRC entity has a
+   * RRC PDU ready to send
    * 
    * \param params 
    */
@@ -123,7 +124,7 @@
 template <class C>
 void LtePdcpSpecificLtePdcpSapProvider<C>::TransmitPdcpSdu (TransmitPdcpSduParameters params)
 {
-  m_pdcp->DoTransmitPdcpSdu (params.pdcpSdu);
+  m_pdcp->DoTransmitPdcpSdu (params);
 }
 
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/lte/model/lte-rlc-am.cc ns-3.34/src/lte/model/lte-rlc-am.cc
--- ns-3.33/src/lte/model/lte-rlc-am.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/lte/model/lte-rlc-am.cc	2021-07-14 10:31:07.000000000 -0700
@@ -119,7 +119,11 @@
                    BooleanValue (false),
                    MakeBooleanAccessor (&LteRlcAm::m_txOpportunityForRetxAlwaysBigEnough),
                    MakeBooleanChecker ())
-
+    .AddAttribute ("MaxTxBufferSize",
+                   "Maximum Size of the Transmission Buffer (in Bytes).  If zero is configured, the buffer is unlimited.",
+                   UintegerValue (10 * 1024),
+                   MakeUintegerAccessor (&LteRlcAm::m_maxTxBufferSize),
+                   MakeUintegerChecker<uint32_t> ())
     ;
   return tid;
 }
@@ -133,6 +137,7 @@
   m_statusProhibitTimer.Cancel ();
   m_rbsTimer.Cancel ();
 
+  m_maxTxBufferSize = 0;
   m_txonBuffer.clear ();
   m_txonBufferSize = 0;
   m_txedBuffer.clear ();
@@ -157,17 +162,28 @@
 {
   NS_LOG_FUNCTION (this << m_rnti << (uint32_t) m_lcid << p->GetSize ());
 
-  /** Store PDCP PDU */
-
-  LteRlcSduStatusTag tag;
-  tag.SetStatus (LteRlcSduStatusTag::FULL_SDU);
-  p->AddPacketTag (tag);
-
-  NS_LOG_LOGIC ("Txon Buffer: New packet added");
-  m_txonBuffer.push_back (TxPdu (p, Simulator::Now ()));
-  m_txonBufferSize += p->GetSize ();
-  NS_LOG_LOGIC ("NumOfBuffers = " << m_txonBuffer.size() );
-  NS_LOG_LOGIC ("txonBufferSize = " << m_txonBufferSize);
+  if (m_txonBufferSize + p->GetSize () <= m_maxTxBufferSize || (m_maxTxBufferSize == 0))
+    {
+      /** Store PDCP PDU */
+      LteRlcSduStatusTag tag;
+      tag.SetStatus (LteRlcSduStatusTag::FULL_SDU);
+      p->AddPacketTag (tag);
+
+      NS_LOG_LOGIC ("Txon Buffer: New packet added");
+      m_txonBuffer.push_back (TxPdu (p, Simulator::Now ()));
+      m_txonBufferSize += p->GetSize ();
+      NS_LOG_LOGIC ("NumOfBuffers = " << m_txonBuffer.size() );
+      NS_LOG_LOGIC ("txonBufferSize = " << m_txonBufferSize);
+    }
+  else
+    {
+      // Discard full RLC SDU
+      NS_LOG_LOGIC ("TxonBuffer is full. RLC SDU discarded");
+      NS_LOG_LOGIC ("MaxTxBufferSize = " << m_maxTxBufferSize);
+      NS_LOG_LOGIC ("txonBufferSize    = " << m_txonBufferSize);
+      NS_LOG_LOGIC ("packet size     = " << p->GetSize ());
+      m_txDropTrace (p);
+    }
 
   /** Report Buffer Status */
   DoReportBufferStatus ();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/lte/model/lte-rlc-am.h ns-3.34/src/lte/model/lte-rlc-am.h
--- ns-3.33/src/lte/model/lte-rlc-am.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/lte/model/lte-rlc-am.h	2021-07-14 10:31:07.000000000 -0700
@@ -143,6 +143,7 @@
                                        ///< for retransmission 
   std::vector <RetxPdu> m_retxBuffer;  ///< Buffer for PDUs considered for retransmission
 
+    uint32_t m_maxTxBufferSize; ///< maximum transmission buffer size
     uint32_t m_txonBufferSize; ///< transmit on buffer size
     uint32_t m_retxBufferSize; ///< retransmit buffer size
     uint32_t m_txedBufferSize; ///< transmit ed buffer size
